<?php
require_once(PFAD_TCPDF.'tcpdf.php');

class tkpdf extends TCPDF {
var $tk_titel = '';

function __construct($orientation='P', $unit='mm', $format='A4', $unicode=true, $encoding='UTF-8', $diskcache=false, $pdfa=false){
	if($_SERVER['REQUEST_METHOD'] == 'HEAD'){
		$this->Output('datei.pdf');
	}
	parent::__construct($orientation, $unit, $format, $unicode, $encoding, $diskcache, $pdfa);
	$this->SetMargins(10, 10, 5, true);
	$this->SetAutoPageBreak(true, 10);
	require_once(PFAD_TCPDF.'config/lang/ger.php');
	$this->setLanguageArray($l);
	$this->SetFont('helvetica', '', 10);
}

function setzeTitel($titel){
	$this->tk_titel = $titel;	
}

function ausgabe($name = 'ausgabe.pdf', $dest = 'I'){
	if(!empty($this->tk_titel)){
		$this->SetTitle($this->tk_titel);
		$this->setViewerPreferences(array('DisplayDocTitle'=>'true'));
	}
	$this->SetAuthor($_SESSION['user']['realname']);
	$this->SetCreator('tkswim '.TKSWIM_VERSION.' (https://tkswim.de)');
	global $_db;
	$_db->speichereGeaenderteTabellen();
	parent::output($name, $dest);
	exit;
}

function erzeugeStartkarten($daten, $conf = array()){
	if($conf['sort'] == 'gestapelt'){
		# Startkarten umsortieren
		$haufen = array(1 => array(), 2 => array(), 3 => array());
		$seiten = ceil(count($daten)/3);
		for($s=1;$s<=3;$s++){
			for($i=1;$i<=$seiten;$i++){
				$tmp = array_shift($daten);
				if(is_null($tmp)){
					break;
				}
				$haufen[$s][] = $tmp;
			}
		}
		$daten = array();
		foreach($haufen['1'] as $key => $row){
			$daten[] = $row;
			if(isset($haufen[2][$key])){
				$daten[] = $haufen[2][$key];
			}
			else{
				$daten[] = false;
			}
			if(isset($haufen[3][$key])){
				$daten[] = $haufen[3][$key];
			}
			else{
				$daten[] = false;
			}
		}
		unset($haufen);		
	}
	$this->setPrintHeader(false);
	$this->setPrintFooter(false);
	$this->SetAutoPageBreak(false);
	$this->SetMargins(20, 0);
	$this->AddPage();
	$_hoehekarte = 99;
	$_abstandlinks = 20;
	$nr = 0;
	foreach($daten as $karte){
		if($nr==3){
			$this->AddPage();
			$nr = 0;
		}
		if($karte === false){
			$nr++;
			continue;
		}
		$_y = $nr*$_hoehekarte;
		$_x = $_abstandlinks;
		# Rahmen
		$this->SetXY($_x, $_y);
		$this->cell(180, 99, '', array('LTRB' => array('width' => 0.5)));
		$this->SetXY($_x, $_y);
		$this->cell(180, 26, '', array('B' => array('width' => 0.2)));
		$this->SetXY($_x, $_y+26);
		$this->cell(90, 73, '', array('R' => array('width' => 0.2)));
		$this->SetXY($_x+90, $_y+26);
		$this->cell(90, 9, '', array('B' => array('width' => 0.2)));
		# Texte
		#  Titel
		$this->SetXY($_x, $_y+5);
		$this->SetFont('helvetica', 'B', 10);
		$this->setFontSpacing(1);
		$this->cell(180, 3, 'STARTKARTE', 0, 0, 'C');
		#   Kopfdaten
		$this->setFontSpacing(0);
		#     WkNr, Name, Verein
		$this->SetFont('helvetica', '', 10);
		$this->SetXY($_x+1, $_y+11);
		$this->cell(14, 3, 'WkNr:');
		$this->SetXY($_x+1, $_y+16);
		$this->cell(14, 3, 'Name:');
		$this->SetXY($_x+1, $_y+21);
		$this->cell(14, 3, 'Verein:');
		$this->SetFont('helvetica', 'B', 10);
		$this->SetXY($_x+13, $_y+11);
		$this->cell(15, 3, $karte['wknr']);
		$this->SetXY($_x+13, $_y+16);
		$this->cell(70, 3, $karte['name']);
		$this->SetXY($_x+13, $_y+21);
		$this->cell(70, 3, $karte['verein']);
		#     WkName
		$this->SetFont('helvetica', '', 10);
		$this->SetXY($_x+30, $_y+11);
		$this->cell(14, 3, 'WkName: '.$karte['wkname']);
		#     Jg, Meldezeit
		$this->SetXY($_x+91, $_y+16);
		$this->cell(80, 3, 'Jahrgang: '.$karte['jg']);
		$this->SetXY($_x+91, $_y+21);
		$this->cell(80, 3, 'Meldezeit: '.(isset($karte['meldezeit'])?$karte['meldezeit']:''));
		#   Feld Bemerkung/Unterschrift
		$this->SetXY($_x+1, $_y+28);
		$this->cell(30, 3, 'Bemerkungen:');		
		$this->SetXY($_x+1, $_y+90);
		$this->cell(30, 3, 'Unterschrift ZN:');		
		#   Feld Lauf/Bahn
		$this->SetFont('helvetica', 'B', 11);
		$this->SetXY($_x+91, $_y+28);
		$this->cell(15, 3, 'Lauf: '.(isset($karte['lauf'])?$karte['lauf']:''));
		$this->SetXY($_x+121, $_y+28);
		$this->cell(15, 3, 'Bahn: '.(isset($karte['bahn'])?$karte['bahn']:''));
		#    Feld Endzeit
		$this->SetFont('helvetica', '', 13);
		$this->SetXY($_x+91, $_y+40);
		$this->cell(20, 5, 'Endzeit:');
		$this->SetFont('helvetica', 'B', 20);
		$this->SetXY($_x+136, $_y+65);
		$this->cell(15, 3, ':');
		$this->SetXY($_x+155, $_y+65);
		$this->cell(15, 3, ',');
		$this->SetFont('helvetica', 'I', 10);
		$this->SetXY($_x+155, $_y+90);
		$this->cell(20, 3, 'tkswim.de', 0, 0, 'R');

		$nr++;
	}
}

public function Header(){

}
    
public function Footer() {

}

} # Ende der Klasse, EOF
