<?php
/*
Wettkampfabwicklung, Aktion: dms_aufstellungexportieren
verwendete Templates:
 - [keines]
*/
$_mannschaften = array();
foreach($_wkeinst['dms'] as $key => $schwimmer){
	$_mannschaften[$key] = array(
		'mw' => $key[0],
		'nr' => $key[1],
		'titel' => $key[1].'. Mannschaft '.$_geschlechter[$key[0]],
		'schwimmer' => empty($schwimmer)?false:explode('|', $schwimmer)
	);
}

$fehler = [];
if(!isset($_wkeinst['dmsstreckenzuordnung'])){
	$fehler[] = 'Den Strecken wurden noch keine Schwimmer zugeordnet.';
}
else{
	foreach($_mannschaften as $_m => $mannschaft){
		if(isset($_wkeinst['dmsstreckenzuordnung'][$_m])){
			continue;
		}
		$mwx = $_m[0]=='m'?'männlich':($_m[0]=='w'?'weiblich':'mixed');
		$fehler[] = 'Bei der '.$_m[1].'. Mannschaft '.$mwx.' wurden den Strecken noch keine Schwimmer zugeordnet.';
	}
}
if(count($fehler) > 0){
	$_tmpl->assign('fehler', implode('<br>', $fehler));
}

if(count($fehler) == 0){
	require_once(PFAD_INCLUDE.'class/dms.inc.php');
	$_dms = new dms($_db, $_SESSION['wk_abwickeln']['id']);

	# Daten sammeln
	$pdfdaten = ['teilnehmer'=>[], 'strecken'=>[]];
	foreach($_mannschaften as $_m => $mannschaft){
		$_mw = $_m[0];
		$_wknrplus = $_mw=='w'?1:2;
		# Schwimmer holen
		$_schwimmer = $_schwimmerjg = [];
		if(is_array($mannschaft['schwimmer'])){
			$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name, CONCAT(vorname, ' ', nachname, ' (',YEAR(gebdatum),')') as namejg
						FROM ".DB_PREFIX."mitglieder
						WHERE id IN (".implode(',', $mannschaft['schwimmer']).")
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$_schwimmer = $_db->baueArray('name', 'id');
			$_schwimmerjg = $_db->baueArray('*', 'id');
		}

		# Strecken und gespeicherte Starts holen
		$_strecken = $_dms->holeWettkampfliste(['mw'=>$_mw]);
		$_zuordnung = $_dms->leseStreckenzuordnung($_m);
		$daten = [];
		foreach($_strecken as $nr => $wk){
			$mid = $_zuordnung[$wk['abschnitt']][$wk['lage']][$wk['laenge']];
			$daten[] = array(
				'abschn'  => $wk['abschnitt'],
				'wknr'    => $nr,
				'lauf'    => '',
				'bahn'    => '',
				'strecke' => $wk['laenge'].'m '.$_lagen[$wk['lage']],
				'name'    => $mid===false?'':$_schwimmer[$mid]
			);
		}

		$pdfdaten['teilnehmer'][] = [
			'titel' => $mannschaft['titel'],
			'teilnehmer' => $_schwimmerjg
		];
		$pdfdaten['strecken'][] = [
			'titel' => $mannschaft['titel'],
			'strecken' => $daten
		];
	}

	# PDF erzeugen
	require_once(PFAD_INCLUDE.'class/pdf.inc.php');
	$pdf = new tkpdf;
	# Einstellungen
	$pdf->ezSetMargins(20,20,50,20);
	$optionen = array(
		'aufstellung' => array(
			'fontSize' => 12,
			'titelFontSize' => 12,
			'xPos' => 60,
			'xOrientation' => 'right',
			'shaded' => 0,
			'showLines' => 2,
			'colGap' => 6,
			'rowGap' => 4,
			'innerLineThickness' => 0.5,
			'outerLineThickness' => 1.5,
			'cols' => array('name'=>array('width'=>230))
		),
		'teilnehmer' => array(
			'fontSize' => 10,
			'xPos' => 370,
			'xOrientation' => 'left',
			'shaded' => 0,
			'showLines' => 0,
			'rowGap' => 1,
			'cols' => array('namejg'=>array('width'=>300))
		)
	);
	$spalten = array(
		'aufstellung' => array(
			'abschn'=>'<b>Abs.</b>',
			'wknr'=>'<b>WK</b>',
			'lauf'=>'<b>L</b>',
			'bahn'=>'<b>B</b>',
			'strecke'=>'<b>Strecke</b>',
			'name'=>'<b>Name</b>'
		),
		'teilnehmer' => array(
			'namejg' => ''
		)
	);
	# Daten schreiben
	$pdf->ezSetDy(10);
	$y = $pdf->ezText('<b>'.$_SESSION['wk_abwickeln']['titel'].'</b>',14);
	$pdf->ezSetDy(-10);
	foreach($pdfdaten['teilnehmer'] as $mannschaft){
		$y = $pdf->ezText('<b>'.$mannschaft['titel'].'</b>',12);
		$pdf->ezSetDy(10);
		$pdf->ezTable($mannschaft['teilnehmer'], $spalten['teilnehmer'] ,'', $optionen['teilnehmer']);
		$pdf->ezSetDy(-30);
	}
	foreach($pdfdaten['strecken'] as $mannschaft){
		$pdf->eznewpage();
		$y = $pdf->ezText('<b>'.$mannschaft['titel'].'</b>',14);
		$pdf->ezSetDy(-5);
		$pdf->ezTable($mannschaft['strecken'], $spalten['aufstellung'] ,'', $optionen['aufstellung']);
	}
	$pdf->tk_titel = 'DMS Aufstellung';
	$pdf->tkstream('dms-aufstellung.pdf');
	exit;
}
# EOF
