<?php
/*
Wettkampfabwicklung, Aktion: dms_meldedateigenerieren
verwendete Templates:
 - [keine]
*/
$wkid = $_SESSION['wk_abwickeln']['id'];
require_once(PFAD_INCLUDE.'class/dms.inc.php');
$_dms = new dms($_db, $wkid);

# Daten holen
$daten = [];
# Abschnitte
$query = "SELECT id, nr, DATE_FORMAT(datum, '%d.%m.%Y') as datum, TIME_FORMAT(beginn, '%H:%i') as uhrzeit
			FROM ".DB_PREFIX."abschnitte WHERE wettkampfid = ".$wkid." ORDER BY nr";
$_db->holeDaten($query);
$daten['abschnitte'] = $_db->baueArray('*','id');

# Wettkaempfe
$wettkampfliste = $_dms->holeWettkampfliste();
$daten['wettkaempfe'] = [];
foreach($wettkampfliste as $nr => $wk){
	$wk['id'] = $nr;
	$wk['nr'] = $wk['abschnitt'];
	$wk['disziplin'] = $wk['lage'];
	$wk['laenge'] = $wk['alaenge'];
	$wk['wkart'] = 'e';
	$wk['mw'] = strtoupper($wk['mw']);
	$daten['wettkaempfe'][$nr] = $wk;
}

# Ansprechpartner
$query = "SELECT CONCAT(m.nachname,', ',m.vorname) as name, CONCAT(m.strasse,' ',m.hausnr) as strasse, m.plz, m.ort, m.email, m.id as mid
			FROM ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."vorstand as v
			WHERE m.id = v.mitgliedid AND v.id = ".$_wkeinst['meldedatei']['ansprechpartner'];
$_db->holeDaten($query);
if($_db->holeAnzahl() > 0){
	$daten['ansprechpartner'] = $_db->holeZeile();
	$daten['ansprechpartner']['tel'] = '';
	$daten['ansprechpartner']['fax'] = '';
	$query = "SELECT CONCAT(vorwahl,'/',nummer) as tel, telefonart FROM ".DB_PREFIX."telefon
				WHERE mitgliedid = ".$_db->holeWert('mid')." AND telefonart IN (1,4) ORDER BY tel";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() > 0){
		foreach($_db->baueArray('*','#') as $row){
			if($row['telefonart']==1 and empty($daten['ansprechpartner']['tel'])){
				$daten['ansprechpartner']['tel'] = $row['tel'];
			}
			if($row['telefonart']==4 and empty($daten['ansprechpartner']['fax'])){
				$daten['ansprechpartner']['fax'] = $row['tel'];
			}
		}
	}
}
else{
	$daten['ansprechpartner'] = false;
}
# Kampfrichter
$daten['kampfrichter'] = false;
if(count($_wkeinst['kampfrichter']) > 0){
	$query = "SELECT k.id, CONCAT(nachname,', ',vorname) as name, gruppe, mw
				FROM ".DB_PREFIX."kampfrichter as k, ".DB_PREFIX."mitglieder as m
				WHERE k.id = m.id AND k.id IN (".implode(',',array_keys($_wkeinst['kampfrichter'])).")
				ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	$daten['kampfrichter'] = $_db->baueArray('*', 'id');
	foreach($daten['kampfrichter'] as $kid => $row){
		$daten['kampfrichter'][$kid]['abschnitte'] = explode(',',$_wkeinst['kampfrichter'][$row['id']]);
	}
}

# Einzelstarts
$daten['einzelstarts'] = [];

# IDs holen
$ids = [];
foreach($_wkeinst['dms'] as $m){
	if(empty($m)){
		continue;
	}
	$ids[] = str_replace('|',',',$m);
}
if(count($ids) > 0){
	$query = "SELECT id, CONCAT(nachname, ', ', vorname) as name, dsvid, UCASE(mw) as mw, YEAR(gebdatum) as jg
				FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$ids).") ORDER BY nachname, vorname";
	$_db->holeDaten($query);
}
if(count($ids) > 0 and $_db->holeAnzahl() > 0){
	$daten['einzelstarts'] = $_db->baueArray('*','id');
	foreach($daten['einzelstarts'] as $key => $row){
		$daten['einzelstarts'][$key]['_starts'] = [];
	}

	if($_wkeinst['meldedatei']['streckenmelden'] == 'ja'){
		$mannschaften = $_dms->leseStreckenzuordnung();
		foreach($mannschaften as $mannschaft => $abschnitte){
			foreach($abschnitte as $abschnitt => $disziplinen){
				foreach($disziplinen as $disziplin => $strecken){
					foreach($strecken as $strecke => $mid){
						if($mid === false){
							continue;
						}
						$wknr = $_dms->sucheWettkampfnummer($abschnitt, $disziplin, $strecke, $mannschaft[0]);
						$daten['einzelstarts'][$mid]['_starts'][$wknr] = array(
							'wkid' => $wknr,
							'wknr' => $wknr,
							'zeit' => null
						);
						ksort($daten['einzelstarts'][$mid]['_starts']);
					}
				}
			}
		}	
	}
}
$daten['staffelstarts'] = array();

# Meldung erzeugen
$format = $_wkeinst['meldedatei']['meldeformat'];
$dateiname = $_wkeinst['meldedatei']['dateiname'];
if(substr($dateiname,-4) == '.dsv'){
	$dateiname = substr($dateiname, 0, -4);	
}
switch($format){
	case 'lenex2':
	case 'lenex3':
		require_once(PFAD_INCLUDE.'class/lenex.inc.php');
		$lenex = new lenex;
		$lenex->setzeVersion($format=='lenex2'?'2':'3');
		$datinh = $lenex->erzeugeMeldedatei($daten, $_wkeinst['wettkampfdaten']);
		
		require_once(PFAD_INCLUDE.'class/zip.inc.php');
		$zip = new zipfile;
		$zip->addFile_daten($datinh, $dateiname.'.lef');
		$zip->gebeDateiAus($dateiname.'.lxf', 'application/x-lenexdatei');

	case 'dsv6':
	case 'dsv6_komprimiert':
		require_once(PFAD_INCLUDE.'func/erzeugedsv6datei.inc.php');
		$query = "SELECT bahnlaenge FROM ".DB_PREFIX."wettkaempfe WHERE id = ".$_SESSION['wk_abwickeln']['id'];
		$_db->holeDaten($query);
		$_wkeinst['wettkampfdaten']['bahnlaenge'] = $_db->holeWert();
		$datinh = erzeugeDsv6Datei($daten, $_wkeinst['wettkampfdaten']);
		if($format=='dsv6_komprimiert'){
			require_once(PFAD_INCLUDE.'class/zip.inc.php');
			$zip = new zipfile;
			$zip->addFile_daten($datinh, $dateiname.'.dsv6');
			$zip->gebeDateiAus($dateiname.'.dsv6.zip');
		}
		else{
			header('Content-Type: text/x-dsvdatei');
			header('Content-Length: '.strlen($datinh));
			header('Content-Disposition: attachment; filename="'.$dateiname.'.dsv6"');
			echo $datinh;
			exit;
		}

	default:
		$_tmpl->assign('fehler','Es wurde kein gültiges Format für die Meldedatei angegeben.');
		break;
}
# EOF
