<?php
/*
Wettkampfabwicklung, Aktion: dms_startkarten
verwendete Templates:
 - 42.dms-startkarten.inc.html
*/

$wkid = $_SESSION['wk_abwickeln']['id'];
require_once(PFAD_INCLUDE.'class/dms.inc.php');
$_dms = new dms($_db, $wkid);
$anzahlstrecken = $_dms->holeStreckenAnzahl();
$freiestartkarten = $anzahlstrecken%3;
if($freiestartkarten == 0){
	$freiestartkarten = 3;
}

$_select = array(
	'sort' => array(
		'gestapelt'   => 'gestapelt',
		'fortlaufend' => 'fortlaufend'
	),
	'blanko' => array(
		$freiestartkarten    => $freiestartkarten.' Karte'.($freiestartkarten!=1?'n':''),
		$freiestartkarten+3  => ($freiestartkarten+3).' Karten',
		$freiestartkarten+6  => ($freiestartkarten+6).' Karten',
		$freiestartkarten+9  => ($freiestartkarten+9).' Karten',
		$freiestartkarten+12 => ($freiestartkarten+12).' Karten'
	)
);

$_conf = [
	'mannschaften' => [],
	'sort'   => 'gestapelt',
	'blanko' => 4,
	'namen'  => 1
];

$_select['mannschaften'] = array();
foreach($_wkeinst['dms'] as $mannschaft => $schwimmer){
	$_select['mannschaften'][$mannschaft] = $mannschaft[1].'. Mannschaft '.$_geschlechter[$mannschaft[0]];
}
$_conf['mannschaften'] = array_keys($_select['mannschaften']);

if(!isset($_POST['pdferzeugen'])){
	if(isset($_wkeinst['wettkampfdaten']['startkarten'])){
		$conf = json_decode(str_replace("'",'"',$_wkeinst['wettkampfdaten']['startkarten']), true);
		if(isset($conf['allg'])){
			# =alte Speicherung, kann später weg
			$conf = $conf['allg'];
		}
	}
	else{
		$conf = $_conf;
		$conf['mannschaften'] = array_keys($_select['mannschaften']);
	}
	$_tmpl->assign('select', $_select);
	$_tmpl->assign('conf', $conf);
	$_tmpl->assign('flags', $flags);
	
	$_inh .= $_tmpl->fetch('wettkaempfe/42.dms-startkarten.inc.html');
}
else{
	$conf = $_POST['conf'];
	if(!isset($_POST['conf']['mannschaften'])){
		$mannschaften = array_keys($_wkeinst['dms']);
	}
	else{
		$mannschaften = [];
		foreach($_POST['conf']['mannschaften'] as $m){
			if(!array_key_exists($m, $_wkeinst['dms'])){
				continue;
			}
			$mannschaften[] = $m;
		}
		if(count($mannschaften)<1){
			$mannschaften = array_keys($_wkeinst['dms']);
		}
	}
	$conf['mannschaften'] = $mannschaften;
	$conf['sort'] = (isset($conf['sort']) and array_key_exists($conf['sort'], $_select['sort']))?$conf['sort']:$_conf['sort'];
	$conf['blanko'] = (isset($conf['blanko']) and array_key_exists($conf['blanko'], $_select['blanko']))?$conf['blanko']:$_conf['blanko'];
	# Conf speichern
	$einstellungen = str_replace('"',"'",json_encode($conf));
	$_wkeinst['wettkampfdaten']['startkarten'] = $einstellungen;
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	schreibe_ini_datei(PFAD_INIDATEIEN.$_SESSION['wk_abwickeln']['dateiname'], $_wkeinst, true);

	# ggf. Namen holen
	$_namen = false;
	if(isset($_POST['conf']['namen']) and $flags['dms_streckenzuordnung']){
		$namen = $mids = [];
		$_namen = true;
		foreach($mannschaften as $mannschaft){
			if(!isset($_wkeinst['dms'][$mannschaft]) or empty($_wkeinst['dms'][$mannschaft])){
				continue;
			}
			$mids = array_merge($mids, explode('|', $_wkeinst['dms'][$mannschaft]));
		}
		if(count($mids)>0){
			$query = "SELECT id, CONCAT(vorname, ' ', nachname) as name, YEAR(gebdatum) as jg
						FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$mids).")";
			$_db->holeDaten($query);
			$namen = $_db->baueArray('*', 'id');
		}
	}

	# Karten erzeugen
	$karten = [];
	foreach($mannschaften as $mannschaft){
		$bezeichnung = $mannschaft[1].'. Mannschaft '.$_geschlechter[$mannschaft[0]];
		$mw = $mannschaft[0];
		$_strecken = $_dms->holeWettkampfliste(['mw'=>$mw]);
		$_zuordnung = $_dms->leseStreckenzuordnung($mannschaft);

		foreach($_strecken as $nr => $wk){
			# Namen zuweisen
			$name = ['name'=>'', 'jg'=>''];
			if($_namen and $_zuordnung){
				$mid = $_zuordnung[$wk['abschnitt']][$wk['lage']][$wk['laenge']];
				if($mid !== false){
					$name = $namen[$mid];
				}
			}
			# Karte anlegen
			$karten[] = array(
				'wknr'   => $nr,
				'wkname' => $wk['alaenge'].'m '.$_lagen[$wk['lage']].' '.$_geschlechter[$mw],
				'name'   => $name['name'],
				'verein' => TKSWIM_VEREIN.' ('.$bezeichnung.')',
				'jg'     => $name['jg']
			);
		}
		# leere Karten
		for($i=1;$i<=$conf['blanko'];$i++){
			$karten[] = array(
				'wknr'   => '',
				'wkname' => '',
				'name'   => '',
				'verein' => TKSWIM_VEREIN.' ('.$bezeichnung.')',
				'jg'     => ''
			);
		}
	}

	# PDF erzeugen
	require_once(PFAD_INCLUDE.'class/tkpdf.inc.php');
	$pdf = new tkpdf();
	$pdf->erzeugeStartkarten($karten, ['sort' => $conf['sort']]);
	$pdf->setzeTitel('Startkarten');
	$pdf->ausgabe();
}
# EOF
